using System;
using System.Collections;
using System.Windows.Forms;
using System.Threading;

namespace CsCgrep
{
	/// <summary>
	/// Ώۃt@C擾NX
	/// </summary>
	public class FileRetriever
	{
		/// <summary>
		/// CEBhE
		/// </summary>
		private MainWindow mainWindow;

		public FileRetriever(MainWindow mainWindow)
		{
			this.mainWindow = mainWindow;
		}

		/// <summary>
		/// w肳ꂽtH_ɂ邷ׂẴt@C擾
		/// </summary>
		/// <param name="folder">t@CtH_B</param>
		/// <param name="searchPattern">t@C
		/// ChJ[hwq(*, ?)gpB</param>
		/// <param name="files">t@C̃Xg</param>
		public void GetAllFilesInDirectory(
			string folder, string searchPattern, ref ArrayList files)
		{
			mainWindow.SetStatusBarText("...  " + folder);

            try
            {
                //folderɂt@C擾
                string[] fs =
                    System.IO.Directory.GetFiles(folder, searchPattern);
                //ArrayListɒǉ
                files.AddRange(fs);
            }
            catch (Exception e)
            {
                Log log = Log.GetInstance();
                log.Error(e.Message);
            }
		}

		/// <summary>
		/// w肳ꂽtH_ȉɂ邷ׂẴt@C擾
		/// </summary>
		/// <param name="folder">t@CtH_B</param>
		/// <param name="searchPattern">t@C
		/// ChJ[hwq(*, ?)gpB</param>
		/// <param name="files">t@C̃Xg</param>
		public void GetAllFilesRecursive(
			string folder, string searchPattern, ref ArrayList files)
		{
			mainWindow.SetStatusBarText("...  " + folder);

            try
            {
                //folderɂt@C擾
                string[] fs =
                    System.IO.Directory.GetFiles(folder, searchPattern);
                //ArrayListɒǉ
                files.AddRange(fs);
            }
            catch (Exception e)
            {
                Log log = Log.GetInstance();
                log.Error(e.Message);
            }

            Application.DoEvents();

            try
            {
                //folder̃TutH_擾
                string[] ds = System.IO.Directory.GetDirectories(folder);
                //TutH_ɂt@Cׂ
                foreach (string d in ds)
                {
                    GetAllFilesRecursive(d, searchPattern, ref files);
                }
            }
            catch (Exception e)
            {
                Log log = Log.GetInstance();
                log.Error(e.Message);
            }
		}
	}
}
